package sun.awt.image;

import java.io.IOException;
import java.awt.image.IndexColorModel;
import java.io.BufferedInputStream;
import java.io.InputStream;

public class XbmImageDecoder extends ImageDecoder
{
    private static byte[] XbmColormap;
    private static int XbmHints;
    
    public XbmImageDecoder(InputStreamImageSource inputStreamImageSource, InputStream inputStream) {
        super(inputStreamImageSource, inputStream);
        if (!(this.input instanceof BufferedInputStream)) {
            this.input = new BufferedInputStream(this.input, 80);
        }
    }
    
    private static void error(String s) throws ImageFormatException {
        throw new ImageFormatException(s);
    }
    
    @Override
    public void produceImage() throws IOException, ImageFormatException {
        char[] array = new char[80];
        int n = 0;
        int n2 = 0;
        int n3 = 0;
        int n4 = 0;
        int n5 = 0;
        int n6 = 0;
        int n7 = 1;
        byte[] array2 = null;
        Object colorModel = null;
        int read;
        while (!this.aborted && (read = this.input.read()) != -1) {
            if ((97 <= read && read <= 122) || (65 <= read && read <= 90) || (48 <= read && read <= 57) || read == 35 || read == 95) {
                if (n >= 78) {
                    continue;
                }
                array[n++] = (char)read;
            }
            else {
                if (n <= 0) {
                    continue;
                }
                n = 0;
                if (n7 != 0) {
                    if (n != 7 || array[0] != '#' || array[1] != 'd' || array[2] != 'e' || array[3] != 'f' || array[4] != 'i' || array[5] != 'n' || array[6] != 'e') {
                        error("Not an XBM file");
                    }
                    n7 = 0;
                }
                if (array[n - 1] == 'h') {
                    n2 = 1;
                }
                else if (array[n - 1] == 't' && n > 1 && array[n - 2] == 'h') {
                    n2 = 2;
                }
                else if (n > 2 && n2 < 0 && array[0] == '0' && array[1] == 'x') {
                    int n10 = 0;
                    int n12;
                    for (int j = 2; j < n; n10 = n10 * 16 + n12, ++j) {
                        int n11 = array[j];
                        if ('0' <= n11 && n11 <= '9') {
                            n12 = n11 - 48;
                        }
                        else if ('A' <= n11 && n11 <= 'Z') {
                            n12 = n11 - 65 + 10;
                        }
                        else if ('a' <= n11 && n11 <= 'z') {
                            n12 = n11 - 97 + 10;
                        }
                        else {
                            n12 = 0;
                        }
                    }
                    for (int k = 1; k <= 128; ++n5, k <<= 1) {
                        if (n5 < n4) {
                            if ((n10 & k) != 0x0) {
                                array2[n5] = 1;
                            }
                            else {
                                array2[n5] = 0;
                            }
                        }
                    }
                    if (n5 >= n4) {
                        if (this.setPixels(0, n6, n4, 1, colorModel, array2, 0, n4) <= 0) {
                            return;
                        }
                        n5 = 0;
                        if (n6++ >= n3) {
                            break;
                        }
                        continue;
                    }
                    else {
                        continue;
                    }
                }
                else {
                    int n8 = 0;
                    int i = 0;
                    while (i < n) {
                        int n9;
                        if ('0' <= (n9 = array[i]) && n9 <= '9') {
                            n8 = n8 * 10 + n9 - 48;
                            ++i;
                        }
                        else {
                            n8 = -1;
                            break;
                        }
                    }
                    if (n8 > 0 && n2 > 0) {
                        if (n2 == 1) {
                            n4 = n8;
                        }
                        else {
                            n3 = n8;
                        }
                        if (n4 == 0 || n3 == 0) {
                            n2 = 0;
                        }
                        else {
                            colorModel = new IndexColorModel(8, 2, XbmImageDecoder.XbmColormap, 0, false, 0);
                            this.setDimensions(n4, n3);
                            this.setColorModel(colorModel);
                            this.setHints(XbmImageDecoder.XbmHints);
                            this.headerComplete();
                            array2 = new byte[n4];
                            n2 = -1;
                        }
                    }
                    else {
                        continue;
                    }
                }
            }
        }
        this.input.close();
        this.imageComplete(3, true);
    }
    
    static {
        XbmImageDecoder.XbmColormap = new byte[] { -1, -1, -1, 0, 0, 0 };
        XbmImageDecoder.XbmHints = 30;
    }
}
